#include <sys/types.h>
#include <sys/wait.h>
#include <sys/capability.h>
#include <sys/stat.h>
#include <string.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <stdio.h>
#include <sched.h>
#include <unistd.h>

#define OUTER_UID 1002
#define OUTER_GID 1002

int error(char const* error)
{
	puts(error);
	return -1;
}

int main(int argc, char** argv, char *const *argvp)
{
	int ptmx_fd;
	int pts_id = 0;
	char *device;
	int pid;
	struct clonedata* clonedata = malloc(sizeof(clonedata));

	struct __user_cap_header_struct capset_key;
	struct __user_cap_data_struct capset_data;
	cap_t caps;

	char *newargs[] = { "lxc-usernsexec", "-m", "u:0:100000:1", "-m", "u:1002:1002:1", "-m", "g:0:100000:1", "-m", "g:5:100005:1", "-m", "g:1002:1002:1", "--", "chown", "0:5", NULL, NULL };

	device = malloc(sizeof(char)*20);
	if(argc <= 1) {
		ptmx_fd = open("/dev/ptmx", O_RDWR);
		ioctl(ptmx_fd, TIOCGPTN, &pts_id);
		snprintf(device, 20, "/dev/pts/%d", pts_id);
	} else {
		if(strncmp(argv[1], "/dev/pts/", 9) != 0)
			snprintf(device, 20, "/dev/pts/%s", argv[1]);
		else
			snprintf(device, 20, "%s", argv[1]);
	}

	if(chown(device, -1, OUTER_GID) != 0)
		return error("chown failed");

	newargs[14] = device;
	caps = cap_init();
	cap_set_proc(caps);
	cap_free(caps);
	
	int ret = execve("/usr/local/bin/lxc-usernsexec", newargs, argvp);
	if(ret != 0);
		return error("lxc-usernsexec failed");
	return ret;
}

